Subject: Re: bug#63794: Acknowledgement (Bad error reporting in case of 404 during downloading)

From: Christopher Baines <[email-masked]>
Date: Tue, 30 May 2023 14:29:03 +0100

Maxime Devos <[email-masked]> writes:

> From: Christopher Baines
>> I think the key bits here might be a duplicate of #63634
>
> Looks like I need to upgrade my Guix system to fix substitution
> ... but "guix system build" is currently failing, which needs
> [cycle!].
>
> This time when doing "guix system build" I have a new error:
>
> [...]
> /gnu/store/qsb7s87y575f42zf79hyjih6adsdwpxb-python-fontmath-0.9.3
> vervangen...
> aan het downloaden van
> https://ci.guix.gnu.org/nar/lzip/l0xjgpcglms6ragxdpmjpkln7k4hjhd3-guix-1.4.0-6.dc5430c...
>  guix-1.4.0-6.dc5430c  44.3MiB     4.7MiB/s 00:04 ▕████████▏         ▏
>  45.5%guix substitute: waarschuwing: tijdens het binnenhalen van
>  https://ci.guix.gnu.org/nar/lzip/9y974g8k1rwv8bwxmshc4fl2dzm6cfij-upower-1.90.0:
>  de server is een beetje traag
> guix substitute: waarschuwing: probeer ‘--no-substitutes’ als het
> probleem hardnekkig is
> retrying download of
> '/gnu/store/9y974g8k1rwv8bwxmshc4fl2dzm6cfij-upower-1.90.0' with other
> substitute URLs...
> [...]
> retrying download of
> '/gnu/store/s94ng28j332my12r3qwvndk4w8kg7awx-openbios-qemu-ppc-1.1-1.af97fd7'
> with other substitute URLs...
> guix substitute: waarschuwing: tijdens het binnenhalen van
> https://ci.guix.gnu.org/nar/lzip/crsnsry2c0q55vi58g53qh2fr9ndb9qn-module-import-compiled:
> de server is een beetje traag
> guix substitute: waarschuwing: probeer ‘--no-substitutes’ als het
> probleem hardnekkig is
> guix substitute: waarschuwing: tijdens het binnenhalen van
> https://ci.guix.gnu.org/nar/lzip/qsb7s87y575f42zf79hyjih6adsdwpxb-python-fontmath-0.9.3:
> de server is een beetje traag
> guix substitute: waarschuwing: probeer ‘--no-substitutes’ als het
> probleem hardnekkig is
> retrying download of
> '/gnu/store/crsnsry2c0q55vi58g53qh2fr9ndb9qn-module-import-compiled'
> with other substitute URLs...
> retrying download of
> '/gnu/store/qsb7s87y575f42zf79hyjih6adsdwpxb-python-fontmath-0.9.3'
> with other substitute URLs...
>  guix-1.4.0-6.dc5430c  44.3MiB     3.1MiB/s 00:09 ▕███████████▊      ▏
>  65.6%guix substitute: waarschuwing: tijdens het binnenhalen van
>  https://ci.guix.gnu.org/nar/lzip/9y974g8k1rwv8bwxmshc4fl2dzm6cfij-upower-1.90.0:
>  de server is een beetje traag
> guix substitute: waarschuwing: probeer ‘--no-substitutes’ als het
> probleem hardnekkig is
> guix substitute: fout: failed to find alternative substitute for
> '/gnu/store/9y974g8k1rwv8bwxmshc4fl2dzm6cfij-upower-1.90.0'
> vervanging van
> /gnu/store/9y974g8k1rwv8bwxmshc4fl2dzm6cfij-upower-1.90.0 mislukt
> guix system: fout: beschadigde invoer tijdens het terugplaatsen van
> het archief uit #<closed: file 7fdab54d1700>
>
> I haven't seen this ‘failed to alternative substitute for [...]’
> before and it seems unrelated to #63634. There is also bad error
> reporting here: failing to find a substitute is not a form of
> ‘corrupted/damaged input’.
>
> I'll do the usual tricks (*) to work-around for now, to get the fix in
> #63634 even though it doesn't fix everything.
>
> (*): while :; do guix system build /etc/config.scm -M1; done

The one workaround I'd suggest is cleaning the guix-daemon's substitute
cache (/var/guix/substitute/cache). That alone should be sufficient to
work around any missing zstd nars.